VCMD0028040100000000COMPONENT          
Node "rSimResource"
{
Name "CollisionDetection"
Id 1
NodeClass 
{
Id 1
VCID "8736dfb2-0338-4fae-a79b-5ba6c8cbb12f"
}
Functionality "rPythonScript"
{
Id 1
Name "PythonScript_Collisions"
Script "from vcScript import *
\nimport vcVector
\n
\napp = getApplication()
\nsim = getSimulation()
\ncomp = getComponent()
\n
\nnode1 = comp.findNode('Link_1') # Size: 100 x 100 x 100
\nnode2 = comp.findNode('Link_2') # Size: 300 x 300 x 300
\n
\ndetector = getSimulation().newCollisionDetector()
\n
\ndef CheckIfNodesInterleaved(node1,node2):
\n  vecNode1 = vcVector.new()
\n  vecNode1 = node1.WorldPositionMatrix.P+node1.BoundCenter
\n  vecNode2 = vcVector.new()
\n  vecNode2 = node2.WorldPositionMatrix.P+node2.BoundCenter
\n  vecCenterToCenter = vcVector.new()
\n  vecCenterToCenter = vecNode1-vecNode2
\n  
\n  if (node1.BoundDiagonal.X+node2.BoundDiagonal.X > abs(vecCenterToCenter.X)) and (node1.BoundDiagonal.Y+node2.BoundDiagonal.Y > abs(vecCenterToCenter.Y)) and (node1.BoundDiagonal.Z+node2.BoundDiagonal.Z > abs(vecCenterToCenter.Z)):
\n    return True
\n  else:
\n    return False
\n  
\ndef OnRun():
\n  detector.NodeListA = [(node1, VC_NODELIST_INCLUDE, VC_NODELIST_NODE )]
\n  detector.NodeListB = [(node2, VC_NODELIST_INCLUDE, VC_NODELIST_NODE )]
\n  
\n  while True:
\n    hit = detector.testOneCollision()
\n    if (not hit):
\n      if (CheckIfNodesInterleaved(node1,node2)):
\n        print 'Collision detected'
\n      else:
\n        print 'No Collision detected'
\n    else:
\n      print 'Collision detected'
\n    delay(1/50.0)"
CompatibilityMode 0
}
Functionality "rPythonScript"
{
Id 2
Name "PythonScript_MoveNode"
Script "from vcScript import *\n
\nnode1 = getComponent().findNode('Link_1') # Size: 100 x 100 x 100\n\ndef OnRun():\n  while True:
\n    node1.Dof.VALUE = 90
\n    
\n    delay(2.0)
\n    
\n    node1.Dof.VALUE = 180
\n    
\n    delay(2.0)    
\n    
\n    node1.Dof.VALUE = 90
\n    
\n    delay(2.0)
\n    
\n    node1.Dof.VALUE = 0
\n    
\n    delay(2.0)\n"
CompatibilityMode 0
}
VCID 8736dfb2-0338-4fae-a79b-5ba6c8cbb12f
OriginalUri vcid:8736dfb2-0338-4fae-a79b-5ba6c8cbb12f
Revision 2
Location 1 0 0 0 0 1 0 0 0 0 1 0 0 0 0 1 
ActiveSimulationLevel detailed
BOMname  "CollisionDetection"

BOMdescription  "CollisionDetection"

Category  ""

VariableSpace ""
{
  Variable "rTVariable<rBool>"
  {
    Name "Visible"
    Value 1
    Group -1130
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      MANAGED
    }
  }
}
Node "rSimLink"
{
Name "Link_1"
Id 2
NodeClass 
{
Id 2
Feature "rPrimitiveBoxFeature"
{
Name "Block"

Matrix 1 0 0 0 0 1 0 0 0 0 1 0 -37.994066 0 92.7658568486 1 
Visible 1
Material  "aluminium"
{
  Ambient
  {
    Red 0.128000006079674
    Green 0.128000006079674
    Blue 0.128000006079674
  }
  Diffuse
  {
    Red 0.560000002384186
    Green 0.560000002384186
    Blue 0.560000002384186
  }
  Specular
  {
    Color
    {
      Red 0.643999993801117
      Green 0.643999993801117
      Blue 0.643999993801117
    }
    Shininess 0.400000005960464
  }
}

Length 
{
  Expression "100 {mm}"
}

Width 
{
  Expression "100 {mm}"
}

Height 
{
  Expression "100 {mm}"
}

}
}
Dof  "Translational"
{
  Name "Link_1"
  Properties
  {
  }
  JointValue 0
  MinLimit
  {
    Expression "-180.0"
  }
  MaxLimit
  {
    Expression "180.0"
  }
  AxisType 0
  JointDeflection
  {
    Expression "VALUE"
  }
}
Offset 
{
  Expression "Tx(-107.005934).Ty(103.123202)"
}
}
Node "rSimLink"
{
Name "Link_2"
Id 3
NodeClass 
{
Id 3
Feature "rPrimitiveBoxFeature"
{
Name "Block_1"

Visible 1
Material  "black_smoke_glass"
{
  Ambient
  {
    Red 0.025000000372529
    Green 0.025000000372529
    Blue 0.025000000372529
  }
  Diffuse
  {
    Red 0.100000001490116
    Green 0.100000001490116
    Blue 0.100000001490116
  }
  Specular
  {
    Color
    {
      Red 0.100000001490116
      Green 0.100000001490116
      Blue 0.100000001490116
    }
    Shininess 1
  }
  Transparency
  {
    Constant
    Value 0.300000011920929
  }
}

Length 
{
  Expression "300 {mm}"
}

Width 
{
  Expression "300 {mm}"
}

Height 
{
  Expression "300 {mm}"
}

}
}
Dof  "Translational"
{
  Name "J1"
  Properties
  {
  }
  JointValue 0
  MinLimit
  {
    Expression "-180.0"
  }
  MaxLimit
  {
    Expression "180.0"
  }
  AxisType 0
  JointDeflection
  {
    Expression "VALUE"
  }
}
Offset 
{
  Expression ""
}
}
}
